import java.io.*;
import java.net.*;
import java.nio.ByteBuffer;
import javax.swing.JFrame;
import javax.swing.JPanel;
import java.awt.BorderLayout;
import java.awt.Dimension;
import javax.swing.JTextField;
import java.awt.Rectangle;
import javax.swing.JLabel;
import javax.swing.JButton;

class SRsender implements Runnable {

       public static int basepkt, nextpkt, janela, timeoutcount;	//Valores do SR
       public static boolean[] recebidos;				//Marca pacotes como recebidos
       public static boolean retry, end;			//Diz que deu timeout e acabou envio
       public static DatagramSocket serverSocket;		//Socket usado para enviar/receber
       public static int porta = 20004;
       public String file;
       public InetAddress destino;
	private static JFrame senderFrame = null;  //  @jve:decl-index=0:visual-constraint="215,65"
	private static JPanel senderPane = null;
	private static JTextField ipField = null;
	private static JTextField fileField = null;
	private static JLabel ipLabel = null;
	private static JLabel fileLabel = null;
	private static JButton startButton = null;
	private static boolean con=false;
       
       //Retorna um int como um array de 4 bytes
       
	/**
	 * This method initializes startButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private static JButton getStartButton() {
		if (startButton == null) {
			startButton = new JButton();
			startButton.setBounds(new Rectangle(101, 125, 152, 26));
			startButton.setText("Comear");
			startButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if(!con){
						con=true;
						try {
							Thread t = new Thread(new SRsender(ipField.getText(),fileField.getText()));
							t.start();
						} catch (UnknownHostException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
					}
				}
			});
		}
		return startButton;
	}

	public static void main(String[] args){
		JFrame frame = getSenderFrame();
		frame.setVisible(true);

	}
	
	public static byte[] intToBytes( int i ) {
           ByteBuffer bb = ByteBuffer.allocate(4);
           bb.putInt(i);
           return bb.array();
       }
       //Mtodos que pegam valores dos pacotes
       public static int getACK(byte[] receiveData){
               int value = 0;
               for (int i = 0; i <= 3; i++)
                        value = (value << 8) + (receiveData[i] & 0xff);
               return value;
       }
       public static int makechecksum(byte[] array){
               int r=0;
               for(int i=0; i<=503; ++i) r+=array[i];
               return r;
       }
       public static int makebigchecksum(byte[] array){
           int r=0;
           for(int i=0; i<=507; ++i) r+=array[i];
           return r;
       }
       public static int getchecksum( byte[] i ) {
               int value = 0;
               for (int j = 4; j <= 7; ++j)
                        value = (value << 8) + (i[j] & 0xff);
               return value;
       }
       public static int makeACKchecksum(byte[] array){
               int r=0;
               for(int i=0; i<=3; ++i) r+=array[i];
               return r;
       }

       //Marca um pacote como recebido (usado pela thread que recebe ACKs)
       public static void mark(int i){
               recebidos[i%janela] = true;
       }

       public SRsender(String file, String a) throws UnknownHostException{
		   this.file = file;
		   this.destino = InetAddress.getByName(a);
	   }
	   
	   public void run(){
			try {
				send();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
	   public void send() throws Exception {

        //       String file = "np.zip";
               File f = new File(this.file);


               if(f.exists()){
                       int size = (int) f.length();

                       serverSocket = new DatagramSocket(porta);
                       byte[] receiveData = new byte[4]; byte[] sendData = new byte[512];

                       //L o arquivo
                       FileInputStream inFile = new FileInputStream(file);
                       BufferedInputStream in = new BufferedInputStream(inFile);
                       System.out.println(inFile);
             //          byte[] fileInBytes = new byte[size];
              //         inFile.read(fileInBytes);

                       //Quantidade de pacotes a serem enviados, e outros dados do SR
                       int pacotes = size/500;
                       if (size%500 != 0) ++pacotes;
                       basepkt=0;
                       nextpkt=0;
                       janela = 15;		//Pode mexer nesse tamanho (melhor=15?)
                       recebidos = new boolean[janela];
                       timeoutcount=0;
                       
                       //Lista de pacotes da janela (que esto sendo enviados)
                       byte[][] hash = new byte[janela][509];
                       for(int i=0; i<janela; ++i){
                    	   int q=i%janela;
                    	   System.out.println(in.read(hash[q], 0, 500));
                    	   byte[] temp = intToBytes(i);
                    	   hash[q][500] = temp[0];
                           hash[q][501] = temp[1];
                           hash[q][502] = temp[2];
                           hash[q][503] = temp[3];
                           temp = intToBytes(makechecksum(hash[q]));
                           hash[q][504] = temp[0];
                           hash[q][505] = temp[1];
                           hash[q][506] = temp[2];
                           hash[q][507] = temp[3];
                       }
                       //Inicializa a lista com os primeiros <janela> pacotes
                       
                       System.out.println("(Servidor) Cliente conectado.");

                       //Envia o tamanho do arquivo, assim como confirma a conexo
                       byte[] sizeBytes = new byte[512];
                       byte[] tmp = file.getBytes();
                       
                       for(int i=0;i<tmp.length;++i) sizeBytes[i] = tmp[i];
                       
                       sendData = intToBytes(size);
                       sizeBytes[500] = sendData[0];
                       sizeBytes[501] = sendData[1];
                       sizeBytes[502] = sendData[2];
                       sizeBytes[503] = sendData[3];
                       sendData = intToBytes(tmp.length);
                       sizeBytes[504] = sendData[0];
                       sizeBytes[505] = sendData[1];
                       sizeBytes[506] = sendData[2];
                       sizeBytes[507] = sendData[3];
                       sendData = intToBytes(makebigchecksum(sizeBytes));
                       sizeBytes[508] = sendData[0];
                       sizeBytes[509] = sendData[1];
                       sizeBytes[510] = sendData[2];
                       sizeBytes[511] = sendData[3];
                       
                       //ACKs tero 9 bytes (ACK+checksum+nada)
                       receiveData = new byte[1];
                       DatagramPacket receivePacket = new DatagramPacket(receiveData, receiveData.length);
                       
                       //Espera confirmao de que o cliente recebeu confirmao da conexo \o/
                       while(true){
                    	   System.out.println(sizeBytes[0]);
                    	   serverSocket.send(new DatagramPacket(sizeBytes, sizeBytes.length, destino, porta));
                    	   System.out.println(destino);
                    	   //Espera 3s (triplo do cliente)
                    	   serverSocket.setSoTimeout(3000);
                    	   try{
                    		   serverSocket.receive(receivePacket);
                    		   if(receiveData[0] == 50) break;
                    	   } catch (SocketTimeoutException e){
                    		   break;
                    	   }
                       }
                       //Se der timeout, assume que cliente confirmou conexo
                       
                       sendData = new byte[509];
                       //Inicia a thread que recebe ACKs
                       Thread sendThread = new Thread(new Receiver());
                       sendThread.setDaemon(true);
                       sendThread.start();

                       //Se der 10 timeouts, pra envio (assume que cliente recebeu)
                       while(basepkt<pacotes && timeoutcount<10){
                    	   		//Se puder enviar o prximo pacote...
                               if(nextpkt < pacotes && nextpkt < basepkt+janela){
                            	   //Se o prximo pacote ainda no foi recebido...
                            	   if(!recebidos[nextpkt%janela]){

                            		 serverSocket.send(new DatagramPacket(hash[nextpkt%janela], hash[nextpkt%janela].length, destino, porta));
                                     System.out.print(""); //wtfdeixamaisrpido
                            	   }
                                       ++nextpkt;

                               }
                               //Move a janela
                               while(basepkt < pacotes && recebidos[basepkt%janela]){
                            	   int q=basepkt%janela;
                            	   in.read(hash[q], 0, 500);
                            	   byte[] temp = intToBytes(basepkt+janela);
                            	   hash[q][500] = temp[0];
                                   hash[q][501] = temp[1];
                                   hash[q][502] = temp[2];
                                   hash[q][503] = temp[3];
                                   temp = intToBytes(makechecksum(hash[q]));
                                   hash[q][504] = temp[0];
                                   hash[q][505] = temp[1];
                                   hash[q][506] = temp[2];
                                   hash[q][507] = temp[3];
                                   recebidos[basepkt%janela] = false;
                            	   ++basepkt;
                               }
                               if(retry) {	//Se for pra reenviar... (deu timeout)
                            	   retry = false;
                            	   nextpkt = basepkt;	//Volta para comeo da janela
                               }
                               if(nextpkt < basepkt) nextpkt = basepkt;
                    //         System.out.println(basepkt+" "+nextpkt);
                       }

                       System.out.println("(Servidor) Arquivo provavelmente enviado.");
                       inFile.close();
               } else System.out.println("Arquivo inexistente.");

               con = false;
       }
	/**
	 * This method initializes senderFrame	
	 * 	
	 * @return javax.swing.JFrame	
	 */
	private static JFrame getSenderFrame() {
		if (senderFrame == null) {
			senderFrame = new JFrame();
			senderFrame.setSize(new Dimension(384, 198));
			senderFrame.setContentPane(getSenderPane());
		}
		return senderFrame;
	}
	/**
	 * This method initializes senderPane	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private static JPanel getSenderPane() {
		if (senderPane == null) {
			fileLabel = new JLabel();
			fileLabel.setBounds(new Rectangle(12, 86, 85, 16));
			fileLabel.setText("Arquivo:");
			ipLabel = new JLabel();
			ipLabel.setBounds(new Rectangle(21, 27, 38, 16));
			ipLabel.setText("IP:");
			senderPane = new JPanel();
			senderPane.setLayout(null);
			senderPane.add(getIpField(), null);
			senderPane.add(getFileField(), null);
			senderPane.add(ipLabel, null);
			senderPane.add(fileLabel, null);
			senderPane.add(getStartButton(), null);
		}
		return senderPane;
	}
	/**
	 * This method initializes ipField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private static JTextField getIpField() {
		if (ipField == null) {
			ipField = new JTextField();
			ipField.setBounds(new Rectangle(61, 22, 256, 29));
		}
		return ipField;
	}
	/**
	 * This method initializes fileField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private static JTextField getFileField() {
		if (fileField == null) {
			fileField = new JTextField();
			fileField.setBounds(new Rectangle(64, 79, 257, 31));
		}
		return fileField;
	}
}


//Thread que recebe ACKs
class Receiver implements Runnable {
	public void run(){
		receive();
	}

	public void receive(){
		try {
			byte[] ack = new byte[9];
			DatagramPacket dp = new DatagramPacket(ack,ack.length);
			while(true){
				SRsender.serverSocket.setSoTimeout(500);
				try{
					SRsender.serverSocket.receive(dp);
					SRsender.timeoutcount = 0;
					//Se o pacote estiver sertu...
					if(SRsender.getchecksum(ack) == SRsender.makeACKchecksum(ack)){
						int ACK = SRsender.getACK(ack);
						//ACK -1 significa que cliente recebeu tudo
						if(ACK==-1) SRsender.timeoutcount = 10;
						else SRsender.mark(ACK);
					}
				} catch (SocketTimeoutException e){
					//Se deu timeout, diz pra reenviar e aumenta contador de timeouts
					System.out.println("TO"+SRsender.basepkt);
					SRsender.retry = true;
					++SRsender.timeoutcount;
				}

			}


		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}



	}

}