package cliente;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.net.*;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.SourceDataLine;
import javax.sound.sampled.TargetDataLine;

public class AudioService {
	protected boolean gravando;
	protected boolean reproduzindo;
	Thread threadCaptura;
	Thread threadReproducao;
	ByteArrayOutputStream saidaAudio;
	public static int porta = 20005;

	private void startRecord(final InetAddress IP, final DatagramSocket socket) {
		try {

			final AudioFormat formato = getFormat();
			DataLine.Info info = new DataLine.Info(TargetDataLine.class, formato);
			final TargetDataLine linha = (TargetDataLine) AudioSystem
			.getLine(info);
			linha.open(formato);
			linha.start();

			Runnable runner = new Runnable() {
				int bufferSize = 40;
				byte buffer[][] = new byte[200][bufferSize];

				public void run() {
					DatagramPacket sendPacket;
					gravando = true;
					try {
						int count;
						while (gravando) {
							for(int i = 0; i < 40; i++){
								count = linha.read(buffer[i], 0, buffer[i].length);
								if (count > 0) {
									sendPacket = new DatagramPacket(buffer[i], buffer[i].length,
											IP, porta);
									socket.send(sendPacket);
								}
							}
						}
						saidaAudio.close();
						linha.close();
					} catch (IOException e) {
						System.err.println(e);
						System.exit(-1);
					}
				}
			};
			threadCaptura = new Thread(runner);
			threadCaptura.start();

		} catch (LineUnavailableException e) {
			System.err.println(e);
			System.exit(-2);
		}
	}

	private void startPlay(final DatagramSocket socket) {
		try {
			final byte audio[] = new byte[40];
			final DatagramPacket packet = new DatagramPacket(audio,audio.length);
			final AudioFormat formato = getFormat();
			DataLine.Info info = new DataLine.Info(SourceDataLine.class, formato);
			final SourceDataLine line = (SourceDataLine) AudioSystem.getLine(info);
			line.open(formato);
			line.start();

			Runnable runner = new Runnable() {
				public void run() {
					try {
						reproduzindo = true;
						socket.receive(packet);

						while (true) {
							socket.receive(packet);
							line.write(audio, 0,audio.length);
						}
					} catch (IOException e) {
						System.err.println(e);
						System.exit(-3);
					}
				}
			};
			threadReproducao = new Thread(runner);
			threadReproducao.start();
		} catch (Exception e) {
			System.err.println(e);
			System.exit(-4);
		}
	}

	private AudioFormat getFormat() {
		float sampleRate = 8000;
		int sampleSizeInBits = 8;
		int channels = 1;
		boolean signed = true;
		boolean bigEndian = true;
		return new AudioFormat(sampleRate, sampleSizeInBits, channels, signed,
				bigEndian);
	}

	private ByteArrayOutputStream stopRecord() {
		try {
			gravando = false;
			threadCaptura.join();
		} catch (InterruptedException e) {
			System.exit(1);
		}
		return saidaAudio;
	}

	private void stopPlay() {
		try {
			reproduzindo = false;
			threadReproducao.join();
		} catch (InterruptedException e) {
			System.exit(1);
		}
	}
	
	public void iniciarConversa(String endereco){
		try {
			DatagramSocket socket = new DatagramSocket(porta);
			InetAddress ip = InetAddress.getByName(endereco);
			startRecord(ip, socket);
			startPlay(socket);
		} catch (Exception e) {
			e.printStackTrace();
			System.err.println(e);
		}

	}
	
	public void pararConversa(){
		stopRecord();
		stopPlay();
	}

}
