package cliente;
import java.net.*;
import java.util.Scanner;
import java.util.Vector;
import java.nio.ByteBuffer;

public class ChatUser {

	public static InetAddress IPuser;
	public static DatagramSocket sendSocket;
	public static DatagramSocket ackSocket;
	public static DatagramSocket noticeSocket;
	public static boolean connected;
	public static int porta = 5643;
	public static Conversa conversa;

	public static byte[] intToBytes( int i ) {
		ByteBuffer bb = ByteBuffer.allocate(4);
		bb.putInt(i);
		return bb.array();
	}
	public static byte[] shortToBytes( int i ) {
		ByteBuffer bb = ByteBuffer.allocate(2);
		bb.putShort((short)i);
		return bb.array();
	}
	public static int getlength(byte[] array) {
		int value = 0;
		for (int j = 500; j <= 501; ++j)
			value = (value << 8) + (array[j] & 0xff);
		return value;
	}
	public static int getsequence(byte[] array) {
		int value = 0;
		for (int j = 502; j <= 505; ++j)
			value = (value << 8) + (array[j] & 0xff);
		return value;
	}
	public static int getchecksum(byte[] array) {
		int value = 0;
		for (int j = 506; j <= 509; ++j)
			value = (value << 8) + (array[j] & 0xff);
		return value;
	}
	public static int makechecksum(byte[] array){
		int r=0;
		for(int i=0; i<=505; ++i) r+=array[i];
		return r;
	}
	public static int getACK(byte[] array) {
		int value = 0;
		for (int j = 0; j <= 3; ++j)
			value = (value << 8) + (array[j] & 0xff);
		return value;
	}


	public ChatUser(Vector<String> ips) throws Exception {
		conversa = new Conversa();
		sendSocket = new DatagramSocket(porta);
		ackSocket = new DatagramSocket(porta+1);
		noticeSocket = new DatagramSocket(porta+2);
		connected = true;

		for(int i=0; i < ips.size(); ++i)
			conversa.add(InetAddress.getByName(ips.elementAt(i)));

		Thread noticeThread = new Thread(new noticeReceiver());
		noticeThread.start();
	}

	public static void add(InetAddress a) {
		conversa.add(a);
	}

	public static void remove(InetAddress a) {
		conversa.remove(a);
	}

	public static void notif(){
		conversa.add(IPuser);
		for(int i=0;i<conversa.membros.size();++i){
			if(!conversa.membros.elementAt(i).equals(IPuser)){
				Thread sendN = new Thread(new sendNotice(conversa.membros.elementAt(i)));
				sendN.start();
			}
		}

	}

	public void sender(String mes){
		try{
			System.out.println("a");
			byte[] message = mes.getBytes();
			for(int i=0;i<ChatUser.conversa.membros.size();++i){
				System.out.println(mes);
				Thread send = new Thread(new sendMessage(message,ChatUser.conversa.sequence,ChatUser.conversa.membros.elementAt(i)));
				send.start();
			} 
		} catch(Exception wtf){}
	}

}



class sendMessage implements Runnable{
	byte[] message;
	int sequence;
	InetAddress IP;

	public sendMessage(byte[] b, int s, InetAddress a){
		this.message = b;
		this.sequence = s;
		this.IP = a;
	}

	public void run(){
		send();
	}

	public void send(){
		try{
			out: while(ChatUser.connected){
				byte[] sendData = new byte[510]; byte[] ack = new byte[4];

				for(int i=0; i<500 && i<message.length; ++i) sendData[i] = message[i];
				byte[] temp = ChatUser.shortToBytes(message.length);
				sendData[500] = temp[0];sendData[501] = temp[1];
				temp = ChatUser.intToBytes(sequence);
				sendData[502] = temp[0];sendData[503] = temp[1];sendData[504] = temp[2];sendData[505] = temp[3];
				temp = ChatUser.intToBytes(ChatUser.makechecksum(sendData));
				sendData[506] = temp[0];sendData[507] = temp[1];sendData[508] = temp[2];sendData[509] = temp[3];
				DatagramPacket dp = new DatagramPacket(ack,ack.length);

				int counter=0;
				for(; counter<40;){
					ChatUser.sendSocket.send(new DatagramPacket(sendData, sendData.length, IP, ChatUser.porta));
					System.out.println("Sent msg to "+IP);
					ChatUser.ackSocket.setSoTimeout(500);
					try{

						ChatUser.ackSocket.receive(dp);
						//				System.out.println("Got ack?"+dp.getAddress()+"  "+IP);
						//Se o ACK estiver correto e for do usurio certo
						if(dp.getAddress().equals(IP) && ChatUser.getACK(ack) == sequence)
							break out;
					} catch (SocketTimeoutException e) {
						++counter;
					}
				}

				if(counter>=40){
					System.out.println("Might not have delivered message to "+IP);
					break out;
				}
			} 
		} catch(Exception wtf){}
	}
}





class sendNotice implements Runnable{
	InetAddress IP;

	public sendNotice(InetAddress a){
		this.IP = a;
	}

	public void run(){
		send();
	}

	public void send(){
		try{
			out: while(true){
				byte[] sendData = new byte[1]; byte[] ack = new byte[1];
				sendData[0] = 7; 
				DatagramPacket dp = new DatagramPacket(ack,ack.length);

				int counter=0;
				for(; counter<60;){
					ChatUser.sendSocket.send(new DatagramPacket(sendData, sendData.length, IP, ChatUser.porta+2));
					System.out.println("Sent notice to "+IP);
					ChatUser.noticeSocket.setSoTimeout(500);
					try{

						ChatUser.noticeSocket.receive(dp);
						if(dp.getAddress().equals(IP) && ChatUser.getACK(ack) == 56)
							break out;
					} catch (SocketTimeoutException e) {
						++counter;
					}
				}

				if(counter>=60){
					System.out.println("Might not have delivered notice to "+IP);
					break out;
				}
			} 
		} catch(Exception wtf){}
	}
}

class noticeReceiver implements Runnable {
	public void run(){
		receive();
	}

	public void receive(){
		try{
			byte[] n = new byte[1];
			DatagramPacket dp = new DatagramPacket(n,n.length);
			while(ChatUser.connected){
				ChatUser.noticeSocket.setSoTimeout(1000);
				try{
					ChatUser.noticeSocket.receive(dp);

					InetAddress sender = dp.getAddress();	//Ip de quem enviou
					//	if(n[0] == 7){

					System.out.println("Got request to remove "+sender);

					byte ack[] = new byte[1];
					ack[0] = 56; 
					ChatUser.conversa.remove(sender);
					ChatUser.sendSocket.send(new DatagramPacket(ack, ack.length,dp.getAddress(), ChatUser.porta+2));

					//	}


				} catch (SocketTimeoutException e){}
			}
		} catch(Exception wtf){}
	}
}