package cliente;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.UnknownHostException;

import javax.swing.JOptionPane;

import exceptions.LoginMuitoGrandeException;
import exceptions.RespostaExtranhaException;
import exceptions.SenhaInvalidaException;
import exceptions.SenhaMuitoGrandeException;
import exceptions.UsuarioNaoEncontradoException;
import exceptions.PacoteCorrompidoException;

public class Cliente implements Runnable{
	public String[] contatos;
	private boolean[] status;
	private InetAddress[] enderecos;
	private int[] portas;
	private PistaDecolagem aeroporto;
	private String login;
	private String senha;
	private gui.FramePrincipal framePrincipal;
	private static gui.FrameLogin frameLogin;

	public Cliente() throws IOException
	{
		//		frameLogin = new gui.FrameLogin();//pra logar eh preciso login e senha, Cliente() é usado pra pegar os dados necessários pra o Cliente("login", "senha")

		//		this.aeroporto = new PistaDecolagem();
		//		Thread receptor1 = new Thread(aeroporto);
		//		receptor1.start();
	}


	public Cliente(String login, char[] senha) throws LoginMuitoGrandeException, SenhaMuitoGrandeException,  UsuarioNaoEncontradoException, RespostaExtranhaException, IOException, SenhaInvalidaException{


		this.aeroporto = new PistaDecolagem();
		Thread receptor = new Thread(aeroporto);
		receptor.start();
		this.login = login;
		this.senha = new String(senha);

		byte[] pedido = new byte[3+login.length()+senha.length];
		if(login.length()>127){
			throw new LoginMuitoGrandeException();
		}else if (senha.length>127){
			throw new SenhaMuitoGrandeException();
		}
		pedido[0] = 1; 
		pedido[1] = (byte)login.length();
		pedido[2] = (byte)senha.length;
		
		for (int i = 3; i < pedido.length; i++) {
			if(i<3+login.length()){
				pedido[i] = (byte) login.charAt(i-3);
			}else{
				pedido[i] = (byte) senha[i-3-login.length()];
			}
		}

		

		DatagramPacket resposta = null;
		boolean mantem = true;
		while(mantem){
			try {
				resposta = this.aeroporto.Enviar(new DatagramPacket(pedido, pedido.length, InetAddress.getByName("172.20.4.205"), 20000));
				mantem = false;
			} catch (PacoteCorrompidoException e) {

			}
		}

		byte[] dados = resposta.getData();

		System.out.println(dados[17]);
		if(dados[17] == 1){
			JOptionPane.showMessageDialog(null, "Usuario nao cadastrado!");
			throw new UsuarioNaoEncontradoException();
		}else if (dados[17] == 2){
			JOptionPane.showMessageDialog(null, "Senha invalida!");
			this.aeroporto.close();
			throw new SenhaInvalidaException();
		}else if (dados[17]>2 || dados[0]<0){
			JOptionPane.showMessageDialog(null, "WTF?");
			throw new RespostaExtranhaException();
		}
		byte[] tamanhoNome = new byte[dados[1]];
		this.status = new boolean[dados[1]];
		this.enderecos = new InetAddress[dados[1]];
		this.portas = new int[dados[1]];

		this.contatos = new String[dados[1]];
		for (int i = 0; i < tamanhoNome.length; i++) {
			tamanhoNome[i] = dados[i+4];
		}

		int k = 1;
		for (int i = 0; i < dados[1]; i++) {
			char[] contato = new char[tamanhoNome[i]];
			for (int j = 0; j < tamanhoNome[i]; j++) {
				contato[j] = (char) dados[4+dados[1]+k];
				k++;
			}
			this.contatos[i] = new String(contato);
		}

		for (int i = 0; i < tamanhoNome.length; i++,k++) {
			if(dados[4+dados[1]+k]==1){
				this.status[i] = true;
			}else if(dados[4+dados[1]+k]==0){
				this.status[i] = false;
			}else{
				throw new RespostaExtranhaException();
			}
		}

	}

	public void iniciarConexao(String contato) throws RespostaExtranhaException, IOException{
		byte[] pedido = new byte[4+login.length()+senha.length()+contato.length()];
		pedido[0] = 2;
		pedido[1] = (byte) login.length();
		pedido[2] = (byte) senha.length();
		pedido[3] = (byte) contato.length();

		for (int i = 0; i < pedido.length-4; i++) {
			if(i<login.length()){
				pedido[i+4] = (byte) login.charAt(i);
			} else if(i<login.length()+senha.length()){
				pedido[i+4] = (byte) senha.charAt(i-login.length());
			} else {
				pedido[i+4] = (byte) contato.charAt(i-login.length()-senha.length());
			}
		}

		DatagramPacket resposta = null;

		boolean mantem = true;
		while(mantem){
			try {
				resposta = aeroporto.Enviar(new DatagramPacket(pedido, pedido.length, InetAddress.getByName("G4C15"), 20000));
				char[] contatoResposta = new char[resposta.getData()[9]];
				for (int i = 0; i < resposta.getData()[9]; i++) {
					contatoResposta[i] = (char) resposta.getData()[i+9];
				}
				String contatoRecebido = new String(contatoResposta);
				if(contato.equals(contatoRecebido)){
					mantem = false;
				}
			} catch (PacoteCorrompidoException e) {

			}
		}

		byte[] dados = resposta.getData();



		byte posicao = posicaoContato(contato);

		this.portas[posicao] = (dados[0] << 24)
		+ ((dados[1] & 0xFF) << 16)
		+ ((dados[2] & 0xFF) << 8)
		+ (dados[3] & 0xFF);

		byte[] ip = {dados[4], dados[5], dados[6], dados[7]};
		this.enderecos[posicao] = InetAddress.getByAddress(ip);

	}

	public void atualizar() throws UnknownHostException, IOException, LoginMuitoGrandeException, SenhaMuitoGrandeException, UsuarioNaoEncontradoException, SenhaInvalidaException, RespostaExtranhaException{
		byte[] pedido = new byte[3+login.length()+senha.length()];
		if(login.length()>127){
			throw new LoginMuitoGrandeException();
		}else if (senha.length()>127){
			throw new SenhaMuitoGrandeException();
		}
		pedido[0] = 1; 
		pedido[1] = (byte)login.length();
		pedido[2] = (byte)senha.length();
		
		for (int i = 3; i < pedido.length; i++) {
			if(i<3+login.length()){
				pedido[i] = (byte) login.charAt(i-3);
			}else{
				pedido[i] = (byte) senha.charAt(i-3-login.length());
			}
		}

		

		DatagramPacket resposta = null;
		boolean mantem = true;
		while(mantem){
			try {
				resposta = this.aeroporto.Enviar(new DatagramPacket(pedido, pedido.length, InetAddress.getByName("172.20.4.205"), 20000));
				mantem = false;
			} catch (PacoteCorrompidoException e) {

			}
		}

		byte[] dados = resposta.getData();

		System.out.println(dados[17]);
		if(dados[17] == 1){
			JOptionPane.showMessageDialog(null, "Usuario nao cadastrado!");
			throw new UsuarioNaoEncontradoException();
		}else if (dados[17] == 2){
			JOptionPane.showMessageDialog(null, "Senha invalida!");
			this.aeroporto.close();
			throw new SenhaInvalidaException();
		}else if (dados[17]>2 || dados[0]<0){
			JOptionPane.showMessageDialog(null, "WTF?");
			throw new RespostaExtranhaException();
		}
		byte[] tamanhoNome = new byte[dados[1]];
		this.status = new boolean[dados[1]];
		this.enderecos = new InetAddress[dados[1]];
		this.portas = new int[dados[1]];

		this.contatos = new String[dados[1]];
		for (int i = 0; i < tamanhoNome.length; i++) {
			tamanhoNome[i] = dados[i+4];
		}

		int k = 1;
		for (int i = 0; i < dados[1]; i++) {
			char[] contato = new char[tamanhoNome[i]];
			for (int j = 0; j < tamanhoNome[i]; j++) {
				contato[j] = (char) dados[4+dados[1]+k];
				k++;
			}
			this.contatos[i] = new String(contato);
		}

		for (int i = 0; i < tamanhoNome.length; i++,k++) {
			if(dados[4+dados[1]+k]==1){
				this.status[i] = true;
			}else if(dados[4+dados[1]+k]==0){
				this.status[i] = false;
			}else{
				throw new RespostaExtranhaException();
			}
		}

	}
	
	public void modificarContatos(byte op, String contato) throws Exception {
		byte[] pedido = new byte[4+login.length()+senha.length()+contato.length()];
		pedido[0] = op;// o botao add setara este byte para 3 e remover para 4
		pedido[1] = (byte) login.length();
		pedido[2] = (byte) senha.length();
		pedido[3] = (byte) contato.length();

		for (int i = 0; i < pedido.length-4; i++) {
			if(i<login.length()){
				pedido[i+4] = (byte) login.charAt(i);
			} else if(i<login.length()+senha.length()){
				pedido[i+4] = (byte) senha.charAt(i-login.length());
			} else {
				pedido[i+4] = (byte) contato.charAt(i-login.length()-senha.length());
			}
		}

		DatagramPacket resposta = null;

		boolean mantem = true;
		while(mantem){
			try {
				
				resposta = aeroporto.Enviar(new DatagramPacket(pedido, pedido.length, InetAddress.getByName("G4C15"), 20000));
				System.out.println(resposta + "aueuhhueauhua\n");
				mantem = false;
			} catch (PacoteCorrompidoException e) {

			}
		}

		byte erro = resposta.getData()[0];
		if(erro == 0){//sem erro
			throw new Exception("Operacao realizada com sucesso.");
		}else if(erro == 1){// Usuario nao encontrado
			throw new Exception("Usuario nao encontrado.");
		}else if(erro == 2){// Senha invalida
			throw new Exception("Senha invalida.");
		}else if(erro == 3){// Ja eh contato
			throw new Exception("Ja � contato.");
		}else if(erro == 4){// Chegou ao limite de contatos
			throw new Exception("Voc� n�o pode adicionar mais contatos.");
		}else if(erro == 5){// Contato nao encontrado
			throw new Exception("Contato n�o encontrado.");
		}
	}

	public void logOff() throws Exception{
		byte[] pedido = new byte[4+login.length()+senha.length()];
		pedido[0] = 5;
		pedido[1] = (byte) senha.length();
		pedido[2] = (byte) login.length();
		for (int i = 3; i < pedido.length; i++) {
			if(i<3+login.length()){
				pedido[i] = (byte) login.charAt(i-3);
			}else{
				pedido[i] = (byte) senha.charAt(i+senha.length()-3);
			}
		}
		DatagramPacket resposta = null;

		boolean mantem = true;
		while(mantem){
			try {
				resposta = aeroporto.Enviar(new DatagramPacket(pedido, pedido.length, InetAddress.getByName("G4C15"), 20000));
				if(resposta.getData()[0] == 0){
					mantem = false;
				}
			} catch (PacoteCorrompidoException e) {

			}
		}
		throw new Exception("Deslogado.");
	}

	public byte posicaoContato(String contato) {
		byte posicao = -1;
		for (byte i = 0; i < this.contatos.length; i++) {
			if(this.contatos[i].equals(contato)){
				posicao = i;
			}
		}
		return posicao;
	}


	public void run() {
		while(true){
			if(this.aeroporto.getResposta().getData()[0]==41){
				// Abre janela de conversa��o
			} else if (this.aeroporto.getResposta().getData()[0]==42){
				// Abre janela de audio
			} else if(this.aeroporto.getResposta().getData()[0]==43){
				// Abre recep�ao de arquivo (transferencia)
			}
		}
	}

	public static void main(String[] args) throws IOException {
		frameLogin = new gui.FrameLogin();

		//		Cliente novoCliente = new Cliente();

	}


	public void close() {
		this.aeroporto.close();
		
	}
}

/*
	public void iniciarConversa(String contato1, String contato2) throws RespostaExtranhaException, IOException{
	byte posicao1 = posicaoContato(contato1);
	iniciarConexao(contato1);
	if(contato2!=null){
		byte posicao2 = posicaoContato(contato2);
		iniciarConexao(contato2);
	}

}
 */