package cliente;



import java.io.*;
import java.net.*;
import java.nio.ByteBuffer;
import java.util.Scanner;

class SRreceiver implements Runnable {

		public static int basepkt, janela = 100;
		public static double packs;			//N de pacotes recebidos por segundo
		public static int counter, size;	//N de pacotes recebidos e tamanho do arquivo
		public static long time0;			//Hora do incio do envio
		public static int porta = 20004;	//Porta (nowaio_O)
		public static InetAddress IPServer;

		//Retorna um int como um array de 4 bytes
        public static byte[] intToBytes( int i ) {
           ByteBuffer bb = ByteBuffer.allocate(4);
           bb.putInt(i);
           return bb.array();
       }

        //Mtodos que pegam valores dos pacotes
       public static int getpkt( byte[] i ) {
               int value = 0;
               for (int j = 500; j <= 503; ++j)
                        value = (value << 8) + (i[j] & 0xff);
               return value;
       }
       public static int getchecksum( byte[] i ) {
               int value = 0;
               for (int j = 504; j <= 507; ++j)
                        value = (value << 8) + (i[j] & 0xff);
               return value;
       }
       public static int makechecksum(byte[] array){
               int r=0;
               for(int i=0; i<=503; ++i) r+=array[i];
               return r;
       }
       public static int makebigchecksum(byte[] array){
           int r=0;
           for(int i=0; i<=507; ++i) r+=array[i];
           return r;
       }
       public static int makeACKchecksum(byte[] array){
               int r=0;
               for(int i=0; i<=3; ++i) r+=array[i];
               return r;
       }
       public static int getbigchecksum( byte[] i ) {
           int value = 0;
           for (int j = 508; j <= 511; ++j)
                    value = (value << 8) + (i[j] & 0xff);
           return value;
       }
       
       public void run(){
    	   try {
			System.out.println("A");receive();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
       }
       
       public void receive() throws Exception {
               System.out.println("(Cliente) Vai comear");
               DatagramSocket clientSocket = new DatagramSocket(porta); //socket UDP
               
         //      InetAddress IPServer = InetAddress.getByName("localhost"); //IP do servidor
      //         String filename = "bum.rar"; //Nome do arquivo

               byte[] sendData = new byte[1];
               byte[] receiveData = new byte[512];
               DatagramPacket sendPacket;
               DatagramPacket receivePacket = new DatagramPacket(receiveData, receiveData.length);
               clientSocket.receive(receivePacket);
               IPServer = receivePacket.getAddress();
               System.out.println("h");
        	   //checa se o pacote est certo
        	   while(!(makebigchecksum(receiveData) == getbigchecksum(receiveData))){
        		   clientSocket.setSoTimeout(500);
        		   try{
        			   clientSocket.receive(receivePacket);
        		   } catch(SocketTimeoutException e){
        			   sendData[0] = -1; //50  arbitrrio, o servidor entende
                       sendPacket = new DatagramPacket(sendData, sendData.length, IPServer, porta);
                       clientSocket.send(sendPacket);
        		   }
               }
        	 //envia resposta indicando que recebeu valor certo
        	   sendData[0] = 50; //50  arbitrrio, o servidor entende
               sendPacket = new DatagramPacket(sendData, sendData.length, IPServer, porta);
               clientSocket.send(sendPacket);
            	   
               //Pega o tamanho do arquivo em bytes
            	   //NO questione como isso funciona
               size = 0;
               for (int i = 500; i < 504; i++)
               {
            	   size = (size << 8) + (receiveData[i] & 0xff);
               }
               //size = tamanho do arquivo em bytes
               int length = 0;
               for (int i = 504; i < 508; i++)
               {
            	   length = (length << 8) + (receiveData[i] & 0xff);
               }
               String filename = new String(receiveData).substring(0, length);
               System.out.println(filename);
            	  //Nome do arquivo
            	   
               File f = new File(filename);
               f.createNewFile();
               FileOutputStream outFile = new FileOutputStream(filename);
//              BufferedOutputStream out = new BufferedOutputStream(outFile);
               
               //Dados recebidos: 500(contedo)+4(sequncia)+4(checksum)+intil
               receiveData = new byte[509];
               receivePacket = new DatagramPacket(receiveData, receiveData.length);

               //pacotes = tamanho do arquivo em pacotes
               int pacotes = size/500;
               if(size%500 != 0) ++pacotes;
               int qualpkt;	//Receber o valor do pacote recebido (heh)
               boolean[] recebidos = new boolean[janela];
               byte[][] hash = new byte[janela][500];

               //ACK+ACKchecksum (9 byte no usado)
               sendData = new byte[9];

               //Inicia a thread que mostra a velocidade de envio
               Thread display = new Thread(new Displayer());
               display.setDaemon(true);
               display.start();
               
               //Usado para saber o tempo total de envio
               time0 = System.currentTimeMillis();
               basepkt=0;
               counter=0;
               
               //Encerra quando receber todos os pacotes do arquivo
               while(basepkt < pacotes){
                       clientSocket.receive(receivePacket);     //recebendo o pacote
                       //Pega o n de sequncia (500..503)
                       qualpkt = getpkt(receiveData);
                       
                        //Se o pacote estiver correto...
                       if(makechecksum(receiveData) == getchecksum(receiveData)){
                               //Copia o contedo pro array do arquivo
                    	   	   //se no j tiver recebido (melhora eficincia)
                               if(!recebidos[qualpkt%janela]) {
                            	   recebidos[qualpkt%janela] = true;
                            	   ++counter;
                            	   //packs usado para marcar a velocidade de envio
                            	   //(quantos pacotes recebeu no segundo)
                            	   packs+=0.5;
                            	   for(int i=0;i<500 && 500*qualpkt+i<size;++i)
                            		   hash[qualpkt%janela][i]=receiveData[i];
                            	}
                               
                               //Bota n de sequncia no ACK
                               byte[] tmp = intToBytes(qualpkt);
                               sendData[0] = tmp[0];
                               sendData[1] = tmp[1];
                               sendData[2] = tmp[2];
                               sendData[3] = tmp[3];
                               //Bota checksum no ACK
                               tmp = intToBytes(makeACKchecksum(tmp));
                               sendData[4] = tmp[0];
                               sendData[5] = tmp[1];
                               sendData[6] = tmp[2];
                               sendData[7] = tmp[3];
                              clientSocket.send(new DatagramPacket(sendData, sendData.length, IPServer, porta));
                       }
                       while(recebidos[basepkt%janela] && basepkt<pacotes){
                    	   recebidos[basepkt%janela] = false;
                    	   if(basepkt==pacotes-1) outFile.write(hash[basepkt%janela], 0, size-500*basepkt);
                    	   else outFile.write(hash[basepkt%janela], 0, 500);
                    	   ++basepkt;
                       }
               }
             //Faz ACK -1 pra encerrar envio
               byte[] tmp = intToBytes(-1);
               sendData[0] = tmp[0];
               sendData[1] = tmp[1];
               sendData[2] = tmp[2];
               sendData[3] = tmp[3];
               tmp = intToBytes(makeACKchecksum(tmp));
               sendData[4] = tmp[0];
               sendData[5] = tmp[1];
               sendData[6] = tmp[2];
               sendData[7] = tmp[3];
               clientSocket.send(new DatagramPacket(sendData, sendData.length, IPServer, porta));
               
               System.out.println("(Cliente) Filesize in packets: "+pacotes);
               //Imprime o tempo de transferncia e velocidade mdia (tamanho/tempo)
               time0 = System.currentTimeMillis()-time0;
               System.out.println("Envio durou "+time0+"ms, velocidade de "+(size/time0)+"KB/s.");
               
               //Cria o arquivo
          //     outFile.write(arquivo);
               
               
               clientSocket.close();
       }
}

//Thread que imprime a quantidade de pacotes recebidos*500 a cada segundo
//Equivale  velocidade em B/s, convertido pra KB/s
//Tambm imprime quantidade de bytes recebidos/tamanho do arquivo em bytes

//Pode ser usado para % de envio

class Displayer implements Runnable {
    public static long t0, t1;
	
	public void run(){
            display();
    }
    
    public void display(){
           while(true){
        	  //Reseta packs para comear a contar
        	   	SRreceiver.packs = 0;
           		t0 = System.currentTimeMillis();
           		do{
           			t1=System.currentTimeMillis();	//Espera 1 segundo
           		} while (t1-t0<1000);
           	  //Imprime packs (que foi modificado pelo receptor)
           		int receb = SRreceiver.counter*500;
           		int percent = (int) receb/SRreceiver.size;
           		int time = (int) ((SRreceiver.size - receb)/SRreceiver.packs);
           		System.out.println(receb+"B / "+SRreceiver.size+"B recebidos ("+percent+"%), "+SRreceiver.packs+" KB/s, trmino em "+time);
           }
    }

}