package conversas;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.SocketException;
import java.net.UnknownHostException;
import java.util.Scanner;

import servidor.PistaPouso;

import cliente.PistaDecolagem;

import exceptions.PacoteCorrompidoException;

public class C2Ctexto implements interfaces.C2Ctexto, Runnable {
	private PistaDecolagem C2CSocket;
	private byte mensagemRecebida1;
	private byte mensagemRecebida2;
	private byte ordem;
	private String login;
	private String sussurro;
	private InetAddress endereco1;
	private InetAddress endereco2;
	private int porta1;
	private int porta2;	
	private Thread recebendo; 

	public String getSussurro() {
		return sussurro;
	}

	public C2Ctexto(PistaDecolagem aeroporto, String login, InetAddress endereco1, int porta1) throws SocketException {
		this.login = login;
		this.endereco1 = endereco1;
		this.porta1 = porta1;
		this.ordem = 0;
		this.C2CSocket = aeroporto;
		this.recebendo = new Thread(aeroporto);
		this.recebendo.start();
	}

	public C2Ctexto(PistaDecolagem aeroporto, String login, InetAddress endereco1, InetAddress endereco2, int porta1, int porta2) throws SocketException {
		this.login = login;
		this.endereco1 = endereco1;
		this.endereco2 = endereco2;
		this.porta1 = porta1;
		this.porta2 = porta2;
		this.ordem = 0;
		this.C2CSocket = aeroporto;
		this.recebendo = new Thread(aeroporto);
		this.recebendo.start();
	}

	public String enviarTexto(String texto) throws UnknownHostException, IOException {
		byte[] pedido = new byte[4+this.login.length()+texto.length()];

		pedido[0] = 51;
		pedido[1] = (byte) this.login.length();
		pedido[2] = (byte) texto.length();
		pedido[3] = this.ordem;

		for (int i = 0; i < pedido.length-4; i++) {
			if(i<login.length()){
				pedido[i+4] = (byte) login.charAt(i);
			} else {
				pedido[i+4] = (byte) texto.charAt(i-login.length());
			}
		}

		DatagramPacket resposta = null;
		boolean mantem = true;
		while(mantem){
			try {
				resposta = new PistaDecolagem().Enviar(new DatagramPacket(pedido, pedido.length, endereco1, porta1));
				if(resposta.getData()[0] == 0){
					mantem = false;
				}
			} catch (PacoteCorrompidoException e) {
				System.out.println("Corrompido!");
			}
		}
		if(endereco2!=null){
			mantem = true;
			while(mantem){
				try {
					resposta = new PistaDecolagem().Enviar(new DatagramPacket(pedido, pedido.length, endereco2, porta2));
					if(resposta.getData()[0] == 0){
						mantem = false;
					}
				} catch (PacoteCorrompidoException e) {

				}
			}
		}

		this.ordem++;
		return (this.login+": "+texto);
	}

	@Override
	public void run() {
		while(true){
			byte[] texto;
			DatagramPacket mensagem =  C2CSocket.getResposta(); 
			texto = mensagem.getData();
			if(texto[0]==51){
				byte[] erro = {0};
				DatagramPacket resposta = new DatagramPacket(erro, 1, mensagem.getAddress(), mensagem.getPort());
				try {
					new PistaPouso().enviar(resposta, (byte) 51);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				if(mensagem.getAddress()==endereco1){
					if(this.mensagemRecebida1+1 == texto[3]){
						this.sussurro = extrairTexto(texto);
						System.out.println(this.sussurro);
						this.mensagemRecebida1++;
					}
				}else if(mensagem.getAddress()==endereco2){
					if(this.mensagemRecebida2+1 == texto[3]){
						this.sussurro = extrairTexto(texto);
						System.out.println(this.sussurro);
						this.mensagemRecebida2++;

					}
				}
			}
		}
	}

	private String extrairTexto(byte[] texto) {
		char[] login = new char[texto[1]];
		char[] fala = new char[texto[2]];
		String whisp;
		for (int i = 0; i < 4+texto[2]+texto[3]; i++) {
			if(i<login.length){
				login[i] = (char) texto[i+4];
			}else if(i<login.length+fala.length){
				fala[i-login.length] = (char) texto[i+4];
			}
		}
		whisp = new String(login)+": "+new String(fala);
		return whisp;
	}

	public static void main(String[] args) throws IOException {
		PistaDecolagem aeroporto = new PistaDecolagem();
		byte[] diogo = {(byte) 192, (byte) 168,0,101}; 
		C2Ctexto conversa = new C2Ctexto(aeroporto, "jvdl", InetAddress.getByName("192.168.0.100"), 20000);
		Thread receber = new Thread(conversa);
		receber.start();
		Scanner in = new Scanner(System.in);
		
		while(true){
			conversa.enviarTexto(in.next());
		}
		
	}
	
}

/* 
 * A conversa entre usuarios tera um formato proprio para os pacotes.
 * 
 * o 1 byte tera o valor da operacao (no caso de texto 51);
 * o 2 byte tera o tamanho do login
 * o 3 byte tera o tamanho do texto
 * o 4 byte tera o valor de ordem da conversa 
 * login
 * texto
 * 
 * 
 * 
 */