package dados;

import java.io.Serializable;

import exceptions.ContatoNaoEncontradoException;
import exceptions.JaCadastradoException;
import exceptions.JaEhContatoException;
import exceptions.NaoPodeAdicionarMaisException;
import exceptions.NaoPodeCadastrarMaisException;
import exceptions.SenhaInvalidaException;
import exceptions.UsuarioNaoEncontradoException;

public class RepositorioUsuarios implements Serializable{
	private static final long serialVersionUID = -2662403865654629801L;
	private Usuario[] usuarios;
	private byte index;

	public Usuario[] getUsuarios() {
		return usuarios;
	}

	public byte getIndex(){
		return this.index;
	}

	public RepositorioUsuarios() {
		this.usuarios = new Usuario[100];
		this.index = 0;
	}

	//devolve a lista de contatos
	public String[] getContatos(String login, String senha) throws UsuarioNaoEncontradoException, SenhaInvalidaException {
		String[] retorno = null;
		boolean encontrou = false;

		for (int i = 0; i < this.index; i++) {
			if(this.usuarios[i].getLogin().equals(login)){
				if(this.usuarios[i].getSenha().equals(senha)){
					retorno = usuarios[i].getContatos();
				}else{
					throw new SenhaInvalidaException();
				}
				encontrou = true;
			}
		}
		if(encontrou){
			return retorno;
		}else{
			throw new UsuarioNaoEncontradoException();
		}
	}

	//devolve o nome do usuario na posicao i
	public String getUsuario(int i) {
		return usuarios[i].getLogin();
	}

	//inseri usuarios
	public void inserirUsuario(Usuario novo) throws JaCadastradoException, NaoPodeCadastrarMaisException{
		checarLimite();
		for (int i = 0; i < this.index; i++) {
			if(this.usuarios[i].equals(novo)){
				throw new JaCadastradoException();
			}
		}
		this.usuarios[this.index] = novo;
		this.index +=1;
	}

	//checa se ja chegou ao limite du usuarios
	private void checarLimite() throws NaoPodeCadastrarMaisException {
		if(this.index==100){
			throw new NaoPodeCadastrarMaisException();
		}

	}

	//apaga usuarios
	public void apagarUsuario(Usuario removido) throws UsuarioNaoEncontradoException{
		boolean encontrou = false;
		for (int i = 0; i < this.index; i++) {
			if(this.usuarios[i].equals(removido)){
				this.index -=1;
				this.usuarios[i]=this.usuarios[this.index];
				encontrou = true;
			}
		}
		if(!encontrou){
			throw new UsuarioNaoEncontradoException();
		}
	}

	public void adicionarContato(String login, String contato) throws JaEhContatoException, NaoPodeAdicionarMaisException, UsuarioNaoEncontradoException {
		boolean encontrou = false;
		boolean encontrouContato = false;

		for (int i = 0; i < this.index; i++) {
			if(this.usuarios[i].getLogin().equals(contato) && encontrouContato){
				encontrouContato = true;
			}
		}
		if(encontrouContato){
			throw new JaEhContatoException();
		}

		for (int i = 0; i < this.index; i++) {
			if(this.usuarios[i].getLogin().equals(login)){
				usuarios[i].addContato(contato);
				encontrou = true;
			}
		}

		if(!encontrou){
			throw new UsuarioNaoEncontradoException();
		}
	}

	public void removerContato(String login, String contato) throws ContatoNaoEncontradoException, UsuarioNaoEncontradoException {
		boolean encontrou = false;

		
		for (int i = 0; i < this.index; i++) {
			
			if(this.usuarios[i].getLogin().equals(login)){
				usuarios[i].apagarContato(contato);
				encontrou = true;
			}
		}

		if(!encontrou){
			throw new UsuarioNaoEncontradoException();
		}
	}

	public int getNumContatos(String login) {
		int retorno = 0;
		for (int i = 0; i < this.index; i++) {
			if(this.usuarios[i].getLogin().equals(login)){
				retorno = usuarios[i].getIndex();
			}
		}
		return retorno;
	}

}
