package dados;

import java.io.Serializable;
import exceptions.ContatoNaoEncontradoException;
import exceptions.JaEhContatoException;
import exceptions.NaoPodeAdicionarMaisException;

public class Usuario implements Serializable{
	private static final long serialVersionUID = -6029617086538821840L;
	private String login;
	private String senha;
	private String[] contatos;
	private byte index;
		
	public byte getIndex() {
		return index;
	}

	public Usuario(String login, String senha) {
		this.login = login;
		this.senha = senha;
		this.contatos = new String[99];
		this.index = 0;
	}
	
	public String[] getContatos() {
		return contatos;
	}
	
	public void addContato(String contato) throws JaEhContatoException, NaoPodeAdicionarMaisException {
		checarLimite();
		for (int i = 0; i < this.index; i++) {
			if(this.contatos[i].equals(contato)){
				throw new JaEhContatoException();
			}
		}
		this.contatos[this.index] = contato;
		this.index +=1;
	}
	
	public void apagarContato(String removido) throws ContatoNaoEncontradoException{
		boolean encontrou = false;
		for (int i = 0; i < this.index && !encontrou; i++) {
			if(this.contatos[i].equals(removido)){
				this.index -=1;
				this.contatos[i]=this.contatos[this.index];
				encontrou = true;
			}
		}
		if(encontrou == false){
			throw new ContatoNaoEncontradoException();
		}
	}
	
	private void checarLimite() throws NaoPodeAdicionarMaisException {
		if(this.index==99){
			throw new NaoPodeAdicionarMaisException();
		}
	}

	public String getLogin() {
		return login;
	}
	public void setLogin(String login) {
		this.login = login;
	}
	public String getSenha() {
		return senha;
	}
	public void setSenha(String senha) {
		this.senha = senha;
	}
	
	
}
