package gui;

import java.awt.*;
import java.awt.event.*;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.SocketTimeoutException;
import java.util.Vector;

import javax.swing.*;

import cliente.ChatUser;
//import cliente.chatReceiver;



public class ChatFrame {

	JTextField outgoing;
	JTextArea incoming;
	JList friends;
	String ip; // temporarioeq3 , tem q ser um arraylista de strings ip
	ChatUser novoChatUser;
	
	
	public ChatFrame(Vector<String> ips)
	{
		
		this.ip = "localhost";
		try {
			novoChatUser = new ChatUser(ips);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Thread receiveThread = new Thread(new chatReceiver());
		receiveThread.start();
		go(); // bota o negocio pra rodar!
	}
	
	public void go()
	{
		JFrame frame = new JFrame("Msn 0.1");
		JPanel painelPrincipal = new JPanel();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	
		/*--------------------------------------------------------------------*/
		// o lugar das mensagens de chegada
		incoming = new JTextArea(30,30);// linhas por colunas
		incoming.setLineWrap(true);
		
		incoming.setWrapStyleWord(true);
		incoming.setEditable(false);
		
		JScrollPane scroller = new JScrollPane(incoming);
		painelPrincipal.add(BorderLayout.WEST, scroller);
		scroller.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		scroller.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		incoming.setVisible(true);
		
		// termina o lugar das mensagens de chegada
		/*--------------------------------------------------------------------*/

		
		/*--------------------------------------------------------------------*/
		//lugar das mensagens de saida
		outgoing = new JTextField(30);
		JButton botaoDeEnviar = new JButton("Enviar");
		botaoDeEnviar.addActionListener(new BotaoDeEnviarListener());
		painelPrincipal.add(BorderLayout.SOUTH, outgoing);
		painelPrincipal.add(botaoDeEnviar);
		frame.getContentPane().add(BorderLayout.CENTER, painelPrincipal);
		//termina o lugar das mensagens de saida
		/*--------------------------------------------------------------------*/

		
		/*--------------------------------------------------------------------*/
		//area dos amigos na conversa atual
		//recebe a lista de amigos ...
		String[] listaTeste = {"paulo", "Jose", "Edmundo"};
		friends = new JList(listaTeste);
		JScrollPane scrollerLista = new JScrollPane(incoming);
		painelPrincipal.add(scrollerLista);
		scrollerLista.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		scrollerLista.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		friends.setVisibleRowCount(30);// linhas de amigos
		
		//friends.setSelectionMode(ListSelectionModel.SINGLE_SELECTION); // soh seleciona um por veztf
		//selecionar e fazer alguma coisa nessa lista?
		
		//adiciona no painel
		painelPrincipal.add(BorderLayout.EAST, friends);
		//fim da área dos amigos na conversa atual
		
		
		/*--------------------------------------------------------------------*/
		//faz a conexão...
		//make some noise... xD
		//threads pra esperar msgs enquanto pode enviar
		/*--------------------------------------------------------------------*/

		
		/*--------------------------------------------------------------------*/

		//configuração de tamanho e visibilidade
		frame.setSize(500, 600);
		frame.setVisible(true);
		/*--------------------------------------------------------------------*/

	}
	
	//metodo pra fazer a conexão ou ir direto pela herança?
	
	
	public class BotaoDeEnviarListener implements ActionListener
	{

		@Override
		public void actionPerformed(ActionEvent e) {
			//envia a mensagem
			try{
				String mensagem  = outgoing.getText();
		//		System.out.println(mensagem);
				novoChatUser.sender(mensagem);
//incoming.append(mensagem + "\n");
				//aqui ele vai pegar a mensagem e passar pra o outro cliente
				//pra "pegar a mensagem" usa-se "outgoing.getText()"
			}
			
			catch(Exception ex)
			{
				ex.printStackTrace();
			}
			
			outgoing.setText(""); // limpa o campo de escrever
			outgoing.requestFocus(); // coloca o cursor no início
		}
		
	}
	
	
	
	
	class chatReceiver implements Runnable {
		public void run(){
			receive();
		}
		
		public void receive(){
			try{
				byte[] message = new byte[510];
				DatagramPacket dp = new DatagramPacket(message,message.length);
				int losscount=0;
				while(novoChatUser.connected){
					novoChatUser.sendSocket.setSoTimeout(1000);
					try{
						novoChatUser.sendSocket.receive(dp);
				//		System.out.println("Got msg?");
						
						InetAddress sender = dp.getAddress();	//Ip de quem enviou, ser usado pra mostrar o nome
						if(novoChatUser.makechecksum(message) == novoChatUser.getchecksum(message)){
				//			System.out.println("yep "+ChatUser.getsequence(message)+" "+ChatUser.sequence);
							if(novoChatUser.getsequence(message)==novoChatUser.conversa.sequence){
								incoming.append(sender+" ("+ChatUser.getsequence(message)+"): "+new String(message).subSequence(0,ChatUser.getlength(message))+"\n");
								byte ack[] = new byte[4];
								ack[0] = message[502]; ack[1] = message[503]; ack[2] = message[504]; ack[3] = message[505]; 
								novoChatUser.sendSocket.send(new DatagramPacket(ack, ack.length,dp.getAddress(), ChatUser.porta+1));
						//		System.out.println(sequence);
								++novoChatUser.conversa.sequence;
						//		System.out.println(sequence);
								
							} else if(novoChatUser.getsequence(message)>novoChatUser.conversa.sequence){
						//		System.out.println(sequence+" "+ChatUser.getsequence(message));
								++losscount;
								if(losscount>10){
									losscount=0;
									++novoChatUser.conversa.sequence;
								}
							} else {
								byte ack[] = new byte[4];
								ack[0] = message[502]; ack[1] = message[503]; ack[2] = message[504]; ack[3] = message[505]; 
								novoChatUser.sendSocket.send(new DatagramPacket(ack, ack.length,dp.getAddress(), ChatUser.porta+1));
							}
			//				System.out.println("Sent ack.");
						}
						
						
					} catch (SocketTimeoutException e){}
				}
			} catch(Exception wtf){}
		}
	}
	
	
	
	
	public static void main(String[] args) {
//		new ChatFrame().go(); // bota o negocio pra rodar!
	}
}
