package gui;

import javax.swing.JFrame;
import javax.swing.JPanel;
import java.awt.BorderLayout;
import java.awt.Dimension;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.SwingUtilities;
import java.awt.GridLayout;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JPasswordField;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.UnknownHostException;

import javax.swing.JButton;

import cliente.Cliente;
import cliente.PistaDecolagem;
import exceptions.LoginMuitoGrandeException;
import exceptions.PacoteCorrompidoException;
import exceptions.RespostaExtranhaException;
import exceptions.SenhaInvalidaException;
import exceptions.SenhaMuitoGrandeException;
import exceptions.UsuarioNaoEncontradoException;

public class FrameLogin {

	private JFrame loginFrame = null;  //  @jve:decl-index=0:visual-constraint="304,25"
	private JPanel wrapperContentPane = null;
	private JMenuBar loginMenuBar = null;
	private JMenu conectarMenu = null;
	private JMenu ajudaMenu = null;
	private JMenuItem cadastrarMenuItem = null;
	private JMenuItem conectarMenuItem = null;
	private JMenuItem ajudaMenuItem = null;
	private JMenuItem sobreMenuItem = null;
	private JPanel botoesPanel = null;
	private JPanel loginPanel = null;
	private JButton conectarButton = null;
	private JButton CadastrarButton = null;
	private JPasswordField senhaPasswordField = null;
	private JLabel senhaLabel = null;
	private JTextField loginTextField = null;
	private JLabel loginLabel = null;
	private gui.FramePrincipal framePrincipal;

	public FrameLogin()
	{

		JFrame frame = getLoginFrame();

		CadastrarButton.addActionListener(new CadastrarButtonListener());//vai esperar por algum clique em "Cadastrar"
		conectarButton.addActionListener(new conectarButtonListener());
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setVisible(true);
	}


	class CadastrarButtonListener implements ActionListener 
	{


		@Override
		public void actionPerformed(ActionEvent e) {
			//cadastra pessoa
			System.out.println("cadastrou");

			String login;
			char[] senha;
			//pega o login e senha digitados
			login = loginTextField.getText();
			System.out.println(login);
			senha = senhaPasswordField.getPassword();
			System.out.println(senha);
			String senhaS = new String(senha);

			byte[] cadastro = new byte[3 + login.length() + senhaS.length()];
			cadastro[0] = 0; // cadastrar
			cadastro[1] = (byte)login.length();
			cadastro[2] = (byte)senhaS.length();

			for (int i = 3; i < cadastro.length; i++) {
				if(i<3+login.length()){
					cadastro[i] = (byte) login.charAt(i-3);
				}else{
					cadastro[i] = (byte) senha[i-3-login.length()];
				}
			}

			DatagramPacket pacote = null;
			DatagramPacket resposta = null;
			try {
				pacote = new DatagramPacket(cadastro, cadastro.length, InetAddress.getByName("g4c15") , 20000);
			} catch (UnknownHostException e2) {
				// TODO Auto-generated catch block
				e2.printStackTrace();
			}
			try {
				PistaDecolagem temp = new PistaDecolagem();
				resposta = temp.Enviar(pacote);
				temp.close();
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (PacoteCorrompidoException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}

			System.out.println(new String(resposta.getData()).substring(17));


		}

	}

	class conectarButtonListener implements ActionListener 
	{

		@Override
		public void actionPerformed(ActionEvent e){
			//conectar
			System.out.println("conectou");
			
			try {
				framePrincipal = new gui.FramePrincipal(loginTextField.getText(), senhaPasswordField.getPassword());
			} catch (LoginMuitoGrandeException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (SenhaMuitoGrandeException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (UsuarioNaoEncontradoException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (RespostaExtranhaException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (SenhaInvalidaException e1) {

			}
	
		}

	}


	/**
	 * This method initializes loginFrame	
	 * 	
	 * @return javax.swing.JFrame	
	 */
	public JFrame getLoginFrame() {
		if (loginFrame == null) {
			loginFrame = new JFrame();
			loginFrame.setSize(new Dimension(289, 193));
			loginFrame.setTitle("SkyPE - Login");
			loginFrame.setJMenuBar(getLoginMenuBar());
			loginFrame.setContentPane(getWrapperContentPane());
		}
		return loginFrame;
	}

	/**
	 * This method initializes wrapperContentPane	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getWrapperContentPane() {
		if (wrapperContentPane == null) {
			wrapperContentPane = new JPanel();
			wrapperContentPane.setLayout(new BorderLayout());
			wrapperContentPane.add(getBotoesPanel(), BorderLayout.SOUTH);
			wrapperContentPane.add(getLoginPanel(), BorderLayout.CENTER);
		}
		return wrapperContentPane;
	}

	/**
	 * This method initializes loginMenuBar	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */
	private JMenuBar getLoginMenuBar() {
		if (loginMenuBar == null) {
			loginMenuBar = new JMenuBar();
			loginMenuBar.add(getConectarMenu());
			loginMenuBar.add(getAjudaMenu());
		}
		return loginMenuBar;
	}

	/**
	 * This method initializes conectarMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getConectarMenu() {
		if (conectarMenu == null) {
			conectarMenu = new JMenu();
			conectarMenu.setText("Conectar");
			conectarMenu.add(getCadastrarMenuItem());
			conectarMenu.add(getConectarMenuItem());
		}
		return conectarMenu;
	}

	/**
	 * This method initializes ajudaMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getAjudaMenu() {
		if (ajudaMenu == null) {
			ajudaMenu = new JMenu();
			ajudaMenu.setText("Ajuda");
			ajudaMenu.add(getAjudaMenuItem());
			ajudaMenu.add(getSobreMenuItem());
		}
		return ajudaMenu;
	}

	/**
	 * This method initializes cadastrarMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getCadastrarMenuItem() {
		if (cadastrarMenuItem == null) {
			cadastrarMenuItem = new JMenuItem("Cadastrar");
		}
		return cadastrarMenuItem;
	}

	/**
	 * This method initializes conectarMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getConectarMenuItem() {
		if (conectarMenuItem == null) {
			conectarMenuItem = new JMenuItem("Conectar");
		}
		return conectarMenuItem;
	}

	/**
	 * This method initializes ajudaMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getAjudaMenuItem() {
		if (ajudaMenuItem == null) {
			ajudaMenuItem = new JMenuItem("Ajuda");
		}
		return ajudaMenuItem;
	}

	/**
	 * This method initializes sobreMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getSobreMenuItem() {
		if (sobreMenuItem == null) {
			sobreMenuItem = new JMenuItem("Sobre");
		}
		return sobreMenuItem;
	}

	/**
	 * This method initializes botoesPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getBotoesPanel() {
		if (botoesPanel == null) {
			botoesPanel = new JPanel();
			botoesPanel.setLayout(new FlowLayout());
			botoesPanel.add(getConectarButton(), null);
			botoesPanel.add(getCadastrarButton(), null);
		}
		return botoesPanel;
	}

	/**
	 * This method initializes loginPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getLoginPanel() {
		if (loginPanel == null) {
			loginLabel = new JLabel();
			loginLabel.setText("Login:");
			senhaLabel = new JLabel();
			senhaLabel.setText("Senha:");
			GridLayout gridLayout = new GridLayout();
			gridLayout.setRows(5);
			gridLayout.setHgap(0);
			loginPanel = new JPanel();
			loginPanel.setLayout(gridLayout);
			loginPanel.add(loginLabel, null);
			loginPanel.add(getLoginTextField(), null);
			loginPanel.add(senhaLabel, null);
			loginPanel.add(getSenhaPasswordField(), null);
		}
		return loginPanel;
	}

	/**
	 * This method initializes conectarButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getConectarButton() {
		if (conectarButton == null) {
			conectarButton = new JButton();
			conectarButton.setText("Conectar");
		}
		return conectarButton;
	}

	/**
	 * This method initializes CadastrarButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCadastrarButton() {
		if (CadastrarButton == null) {
			CadastrarButton = new JButton();
			CadastrarButton.setText("Cadastrar");
		}
		return CadastrarButton;
	}

	/**
	 * This method initializes senhaPasswordField	
	 * 	
	 * @return javax.swing.JPasswordField	
	 */
	private JPasswordField getSenhaPasswordField() {
		if (senhaPasswordField == null) {
			senhaPasswordField = new JPasswordField();
		}
		return senhaPasswordField;
	}

	/**
	 * This method initializes loginTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getLoginTextField() {
		if (loginTextField == null) {
			loginTextField = new JTextField();
		}
		return loginTextField;
	}



	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {

			@Override
			public void run() {
				FrameLogin app = new FrameLogin();
				JFrame frame = app.getLoginFrame();
				frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				frame.setResizable(false);
				frame.setLocationRelativeTo(frame.getParent());
				frame.setVisible(true);
			}
		});
	}

}
