package gui;

import javax.swing.JFrame;
import javax.swing.JPanel;
import java.awt.Dimension;
import java.awt.GraphicsEnvironment;

import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;

import java.awt.CardLayout;
import javax.swing.JSplitPane;
import java.awt.FlowLayout;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.net.UnknownHostException;

import javax.swing.JList;
import javax.swing.JButton;
import javax.swing.JComboBox;

import cliente.Cliente;
import exceptions.LoginMuitoGrandeException;
import exceptions.RespostaExtranhaException;
import exceptions.SenhaInvalidaException;
import exceptions.SenhaMuitoGrandeException;
import exceptions.UsuarioNaoEncontradoException;
import gui.FrameLogin.CadastrarButtonListener;
import javax.swing.JTextField;

public class FramePrincipal {
	
	private String[] data ;
	private String[] status = {"Dispon\u00edvel", "Ocupado", "Ausente"};
	private JFrame mainFrame = null;  //  @jve:decl-index=0:visual-constraint="13,32"
	private JPanel wrapperContentPane = null;
	private JMenuBar barraMenu = null;
	private JMenu acoesMenu = null;
	private JMenu contatosMenu = null;
	private JMenuItem deslogarMenuItem = null;
	private JMenuItem fecharMenuItem = null;
	private JMenuItem adicionarContatoMenuItem = null;
	private JSplitPane wrapperSplitPane = null;
	private JPanel listaContatosPanel = null;
	private JPanel labelListaPanel = null;
	private JLabel listaLabel = null;
	private JMenu ajudaMenu = null;
	private JMenuItem ajudaMenuItem = null;
	private JMenuItem sobreMenuItem = null;
	private JPanel botoesPanel = null;
	private JScrollPane listaAmigosScrollPane = null;
	private JList listaAmigosList = null;
	private JButton conversarButton = null;
	private JButton enviarArquivoButton = null;
	private JButton iniciarChamadaButton = null;
	private JPanel direitaPanel = null;
	private JPanel northPanel = null;
	private JPanel southPanel = null;
	private JLabel statusLabel = null;
	private JComboBox statusComboBox = null;
	private gui.ChatFrame chatFrame;
	private Cliente usuario;
	private JFrame nomeAmigoAddFrame = null;  //  @jve:decl-index=0:visual-constraint="819,52"
	private JPanel nomeAmigoAdd = null;
	private JTextField AdicionarAmigoTextField = null;
	private JButton AdicionarAmigo = null;
	private JFrame arquivoFrame = null;  //  @jve:decl-index=0:visual-constraint="844,160"
	private JPanel arquivoPanel = null;
	private JFrame chamadaFrame = null;  //  @jve:decl-index=0:visual-constraint="482,247"
	private JPanel chamadaPane = null;
	public FramePrincipal(String login, char[] senha) throws LoginMuitoGrandeException, SenhaMuitoGrandeException, UsuarioNaoEncontradoException, RespostaExtranhaException, IOException, SenhaInvalidaException
	{
		
		try {
			this.usuario = new Cliente(login, senha);
		} catch (SenhaInvalidaException e1) {
			this.usuario = null;
			throw new SenhaInvalidaException();
		}


		//String nome = this.usuario.contatos[1] ;
		JFrame frame = getMainFrame();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		//faz a janela iniciar maximizada
		GraphicsEnvironment e = GraphicsEnvironment.getLocalGraphicsEnvironment();
		frame.setMaximizedBounds(e.getMaximumWindowBounds());
		frame.setExtendedState(frame.getExtendedState()|JFrame.MAXIMIZED_BOTH);
		frame.setVisible(true);
	}
	
	
	
	/**
	 * This method initializes mainFrame	
	 * 	
	 * @return javax.swing.JFrame	
	 */
	
	public JFrame getMainFrame() {
		if (mainFrame == null) {
			mainFrame = new JFrame();
			mainFrame.setSize(new Dimension(784, 209));
			mainFrame.setTitle("SkyPE");
			mainFrame.setJMenuBar(getBarraMenu());
			mainFrame.setContentPane(getWrapperContentPane());
		}
		return mainFrame;
	}

	/**
	 * This method initializes wrapperContentPane	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getWrapperContentPane() {
		if (wrapperContentPane == null) {
			wrapperContentPane = new JPanel();
			wrapperContentPane.setLayout(new CardLayout());
			wrapperContentPane.add(getWrapperSplitPane(), getWrapperSplitPane().getName());
		}
		return wrapperContentPane;
	}

	/**
	 * This method initializes barraMenu	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */
	private JMenuBar getBarraMenu() {
		if (barraMenu == null) {
			barraMenu = new JMenuBar();
			barraMenu.add(getAcoesMenu());
			barraMenu.add(getAjudaMenu());
			barraMenu.add(getContatosMenu());
		}
		return barraMenu;
	}

	/**
	 * This method initializes acoesMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getAcoesMenu() {
		if (acoesMenu == null) {
			acoesMenu = new JMenu();
			acoesMenu.setText("Agir!");
			acoesMenu.add(getDeslogarMenuItem());
			acoesMenu.add(getFecharMenuItem());
		}
		return acoesMenu;
	}

	/**
	 * This method initializes contatosMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getContatosMenu() {
		if (contatosMenu == null) {
			contatosMenu = new JMenu();
			contatosMenu.setText("Contatos");
			contatosMenu.add(getAdicionarContatoMenuItem());
			if(this.usuario.contatos != null)
			{
				
				this.data = this.usuario.contatos;
			}
		}
		return contatosMenu;
	}

	/**
	 * This method initializes deslogarMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getDeslogarMenuItem() {
		if (deslogarMenuItem == null) {
			deslogarMenuItem = new JMenuItem("Deslogar");
		}
		return deslogarMenuItem;
	}

	/**
	 * This method initializes fecharMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getFecharMenuItem() {
		if (fecharMenuItem == null) {
			fecharMenuItem = new JMenuItem("Encerrar SkyPE");
		}
		return fecharMenuItem;
	}
	
	/**
	 * This method initializes adicionarContatoMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getAdicionarContatoMenuItem() {
		if (adicionarContatoMenuItem == null) {
			adicionarContatoMenuItem = new JMenuItem("Adicionar Contato");
			adicionarContatoMenuItem.addActionListener(new adicionarContatoMenuItemListener());
		}
		
		
		return adicionarContatoMenuItem;
	}

	class adicionarContatoMenuItemListener implements ActionListener 
	{

		@Override
		public void actionPerformed(ActionEvent arg0) {
			getNomeAmigoAddFrame();
			
		}
		
	}
	/**
	 * This method initializes wrapperSplitPane
	 * 	
	 * @return javax.swing.JSplitPane
	 */
	private JSplitPane getWrapperSplitPane() {
		if (wrapperSplitPane == null) {
			wrapperSplitPane = new JSplitPane();
			wrapperSplitPane.setName("wrapperSplitPane");
			wrapperSplitPane.setRightComponent(getDireitaPanel());
			wrapperSplitPane.setLeftComponent(getListaContatosPanel());
		}
		return wrapperSplitPane;
	}

	/**
	 * This method initializes listaContatosPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getListaContatosPanel() {
		if (listaContatosPanel == null) {
			listaContatosPanel = new JPanel();
			listaContatosPanel.setLayout(new BorderLayout());
			listaContatosPanel.add(getLabelListaPanel(), BorderLayout.NORTH);
			listaContatosPanel.add(getBotoesPanel(), BorderLayout.SOUTH);
			listaContatosPanel.add(getListaAmigosScrollPane(), BorderLayout.CENTER);
			
		}
		return listaContatosPanel;
	}

	/**
	 * This method initializes labelListaPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getLabelListaPanel() {
		if (labelListaPanel == null) {
			listaLabel = new JLabel();
			listaLabel.setText("Amigos");
			labelListaPanel = new JPanel();
			labelListaPanel.setLayout(new FlowLayout());
			labelListaPanel.setSize(300, 600);
			labelListaPanel.add(listaLabel, null);
		}
		return labelListaPanel;
	}

	/**
	 * This method initializes ajudaMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getAjudaMenu() {
		if (ajudaMenu == null) {
			ajudaMenu = new JMenu();
			ajudaMenu.setText("Ajuda");
			ajudaMenu.add(getAjudaMenuItem());
			ajudaMenu.add(getSobreMenuItem());
		}
		return ajudaMenu;
	}

	/**
	 * This method initializes ajudaMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getAjudaMenuItem() {
		if (ajudaMenuItem == null) {
			ajudaMenuItem = new JMenuItem("Ajuda");
		}
		return ajudaMenuItem;
	}

	/**
	 * This method initializes sobreMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getSobreMenuItem() {
		if (sobreMenuItem == null) {
			sobreMenuItem = new JMenuItem("Sobre o SkyPE");
		}
		return sobreMenuItem;
	}

	/**
	 * This method initializes botoesPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getBotoesPanel() {
		if (botoesPanel == null) {
			botoesPanel = new JPanel();
			botoesPanel.setLayout(new FlowLayout());
			botoesPanel.add(getConversarButton(), null);
			botoesPanel.add(getEnviarArquivoButton(), null);
			botoesPanel.add(getIniciarChamadaButton(), null);
		}
		return botoesPanel;
	}

	/**
	 * This method initializes listaAmigosScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getListaAmigosScrollPane() {
		if (listaAmigosScrollPane == null) {
			listaAmigosScrollPane = new JScrollPane();
			listaAmigosScrollPane.setViewportView(getListaAmigosList());
		}
		return listaAmigosScrollPane;
	}

	/**
	 * This method initializes listaAmigosList	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getListaAmigosList() {
		if (listaAmigosList == null) {
			listaAmigosList = new 	JList(usuario.contatos);
		}
		return listaAmigosList;
	}

	/**
	 * This method initializes conversarButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getConversarButton() {
		if (conversarButton == null) {
			conversarButton = new JButton();
			conversarButton.setText("Conversar");
			conversarButton.addActionListener(new conversarButtonListener());
		}
		return conversarButton;
	}

	class conversarButtonListener implements ActionListener
	{

		@Override
		public void actionPerformed(ActionEvent event) {
			//tenho que pegar todos os contatos e repass-los pra o chatFrame
			chatFrame = new ChatFrame(null); //TODO
		}
		
	}
	/**
	 * This method initializes enviarArquivoButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getEnviarArquivoButton() {
		if (enviarArquivoButton == null) {
			enviarArquivoButton = new JButton();
			enviarArquivoButton.setText("EnviarArquivo");
			enviarArquivoButton.addActionListener(new enviarArquivoButtonListener());

		}
		return enviarArquivoButton;
	}
	
	class enviarArquivoButtonListener implements ActionListener
	{

		@Override
		public void actionPerformed(ActionEvent e) 
		{
			//pegar ip e passar pro arquivoFrame
			
		}
		
	}

	/**
	 * This method initializes iniciarChamadaButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getIniciarChamadaButton() {
		if (iniciarChamadaButton == null) {
			iniciarChamadaButton = new JButton();
			iniciarChamadaButton.setText("Iniciar Chamada");
			iniciarChamadaButton.addActionListener(new iniciarChamadaButtonListener());
		}
		return iniciarChamadaButton;
	}

	class iniciarChamadaButtonListener implements ActionListener
	{

		@Override
		public void actionPerformed(ActionEvent e) {
		//inicia a chamada com o outro usuario
			
		}
		
	}
	/**
	 * This method initializes direitaPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getDireitaPanel() {
		if (direitaPanel == null) {
			direitaPanel = new JPanel();
			direitaPanel.setLayout(new BorderLayout());
			direitaPanel.add(getNorthPanel(), BorderLayout.NORTH);
			direitaPanel.add(getSouthPanel(), BorderLayout.SOUTH);
		}
		return direitaPanel;
	}

	/**
	 * This method initializes northPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getNorthPanel() {
		if (northPanel == null) {
			statusLabel = new JLabel();
			statusLabel.setText("Status:");
			FlowLayout flowLayout = new FlowLayout();
			flowLayout.setAlignment(java.awt.FlowLayout.LEFT);
			northPanel = new JPanel();
			northPanel.setLayout(flowLayout);
			northPanel.add(statusLabel, null);
			northPanel.add(getStatusComboBox(), null);
		}
		return northPanel;
	}

	/**
	 * This method initializes southPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getSouthPanel() {
		if (southPanel == null) {
			southPanel = new JPanel();
			southPanel.setLayout(new FlowLayout());
		}
		return southPanel;
	}

	/**
	 * This method initializes statusComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getStatusComboBox() {
		if (statusComboBox == null) {
			statusComboBox = new JComboBox(status);
		}
		return statusComboBox;
	}

	/**
	 * This method initializes nomeAmigoAddFrame	
	 * 	
	 * @return javax.swing.JFrame	
	 */
	private JFrame getNomeAmigoAddFrame() {
		if (nomeAmigoAddFrame == null) {			
			nomeAmigoAddFrame = new JFrame();
			nomeAmigoAddFrame.setSize(new Dimension(263, 89));
			nomeAmigoAddFrame.setTitle("Add Amigo");
			nomeAmigoAddFrame.setContentPane(getNomeAmigoAdd());
			nomeAmigoAddFrame.setVisible(true);
		}
		return nomeAmigoAddFrame;
	}

	/**
	 * This method initializes nomeAmigoAdd	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getNomeAmigoAdd() {
		if (nomeAmigoAdd == null) {
			nomeAmigoAdd = new JPanel();
		//	nomeAmigoAdd.setText("Coloque aqui o nome do seu amigo");
			nomeAmigoAdd.setLayout(new BorderLayout());
			nomeAmigoAdd.add(getJTextField(), BorderLayout.NORTH);
			nomeAmigoAdd.add(getAdicionarAmigo(), BorderLayout.CENTER);
		}
		return nomeAmigoAdd;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextField() {
		if (AdicionarAmigoTextField == null) {
			AdicionarAmigoTextField = new JTextField();
			
		}
		return AdicionarAmigoTextField;
	}

	/**
	 * This method initializes AdicionarAmigo	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getAdicionarAmigo() {
		if (AdicionarAmigo == null) {
			AdicionarAmigo = new JButton();
			AdicionarAmigo.setText("Adicione o amigo");
			AdicionarAmigo.addActionListener(new AdicionarAmigoListener());
			
		}
		return AdicionarAmigo;
	}
	
	class AdicionarAmigoListener implements ActionListener
	{

		@Override
		public void actionPerformed(ActionEvent arg0) {
			//Adiciona um amigo  lista de amigos
			
			try {
				usuario.modificarContatos((byte) 3, AdicionarAmigoTextField.getText());
				usuario.atualizar();
				wrapperSplitPane.setLeftComponent(getListaContatosPanel());
			} catch (Exception e) {
				JOptionPane.showMessageDialog(null, e.getMessage());
				
			}
			
			
		}
		
	}

	/**
	 * This method initializes arquivoFrame	
	 * 	
	 * @return javax.swing.JFrame	
	 */
	private JFrame getArquivoFrame() {
		if (arquivoFrame == null) {			arquivoFrame = new JFrame();
			arquivoFrame.setSize(new Dimension(238, 137));
			arquivoFrame.setTitle("Transferir Arquivos");
			arquivoFrame.setContentPane(getArquivoPanel());
		}
		return arquivoFrame;
	}

	/**
	 * This method initializes arquivoPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getArquivoPanel() {
		if (arquivoPanel == null) {
			arquivoPanel = new JPanel();
			arquivoPanel.setLayout(new BorderLayout());
		}
		return arquivoPanel;
	}

	/**
	 * This method initializes chamadaFrame	
	 * 	
	 * @return javax.swing.JFrame	
	 */
	private JFrame getChamadaFrame() {
		if (chamadaFrame == null) {
			chamadaFrame = new JFrame();
			chamadaFrame.setSize(new Dimension(312, 95));
			chamadaFrame.setTitle("Iniciar Chamada");
			chamadaFrame.setContentPane(getChamadaPane());
		}
		return chamadaFrame;
	}

	/**
	 * This method initializes chamadaPane	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getChamadaPane() {
		if (chamadaPane == null) {
			chamadaPane = new JPanel();
			chamadaPane.setLayout(new BorderLayout());
		}
		return chamadaPane;
	}
	
	public void sumir(){
		mainFrame.setVisible(false);
	}

	public static void main(String[] args) throws LoginMuitoGrandeException, SenhaMuitoGrandeException, SenhaInvalidaException, UsuarioNaoEncontradoException, RespostaExtranhaException, IOException {
		FramePrincipal app = new FramePrincipal(null, null);
		JFrame frame = app.getMainFrame();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		//faz a janela iniciar maximizada
		GraphicsEnvironment e = GraphicsEnvironment.getLocalGraphicsEnvironment();
		frame.setMaximizedBounds(e.getMaximumWindowBounds());
		frame.setExtendedState(frame.getExtendedState()|JFrame.MAXIMIZED_BOTH);
		frame.setVisible(true);
	}

}
