package socketRTP.testes;

// ESTA FUNCIONANDO

import java.io.IOException;
import java.io.File;

import javax.sound.sampled.DataLine;
import javax.sound.sampled.TargetDataLine;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioFileFormat;

public class AudioCapture3 extends Thread {

	private TargetDataLine line;
	private AudioFileFormat.Type targetType;
	private AudioInputStream audioInputStream;
	private File outputFile;

	public AudioCapture3() {
		try{
			AudioFormat audioFormat = getAudioFormat();
			DataLine.Info info = new DataLine.Info(TargetDataLine.class,
					audioFormat);
			line = (TargetDataLine) AudioSystem.getLine(info);
			line.open(audioFormat);
			audioInputStream = new AudioInputStream(line);
			targetType = AudioFileFormat.Type.WAVE;
			outputFile = new File("Teste.wav");
		} catch (Exception e){
			e.printStackTrace();
			System.exit(0);
		}
	}

	public void startRecord() {
		line.start();
		super.start();
	}

	public void stopRecord() {
		line.stop();
		line.close();
	}

	public void run() {
		try {
			AudioSystem.write(audioInputStream, targetType, outputFile);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private AudioFormat getAudioFormat() {
		float sampleRate = 8000.0F;
		int sampleSizeInBits = 16;
		int channels = 1;
		boolean signed = true;
		boolean bigEndian = false;
		return new AudioFormat(sampleRate, sampleSizeInBits, channels, signed,
				bigEndian);
	}

}